<template>
  <code
    ref="preview"
    class="language-json block w-full overflow-x-auto whitespace-pre-wrap rounded-t-sm border bg-transparent p-2"
    >{{ content }}</code
  >
</template>

<script setup lang="ts">
import hljs from 'highlight.js';
import json from 'highlight.js/lib/languages/json';
import 'highlight.js/styles/color-brewer.css';

hljs.registerLanguage('json', json);

import { nextTick, onMounted, ref, watch } from 'vue';

const preview = ref<null | HTMLElement>(null);
const isExtended = ref(false);

onMounted(() => {
  if (!preview.value) return;
  delete preview.value.dataset.highlighted;
  hljs.highlightElement(preview.value);
});

const props = defineProps({
  content: {
    type: String,
    default: '',
  },
});

watch(
  () => props.content,
  async () => {
    if (!preview.value) return;
    delete preview.value.dataset.highlighted;
    await nextTick();
    hljs.highlightElement(preview.value);
  }
);
</script>
